CheckAll	PROC

		mov	dwMode,0
		invoke IsDlgButtonChecked,hDlgMain,IDC_HEAD
		cmp	eax,BST_CHECKED
		jz @F
		mov	dwMode,-1
		invoke IsDlgButtonChecked,hDlgMain,IDC_TAIL
		cmp	eax,BST_CHECKED
		jz @F
		mov	dwMode,2
	@@:
		invoke GetDlgItemInt,hDlgMain,IDE_MEMBERCOUNT,NULL,FALSE
		cmp	eax,DEF_MEMBER_COUNT
		jnc @F
			mov	eax,DEF_MEMBER_COUNT
			push	eax
			invoke SetDlgItemInt,hDlgMain,IDE_MEMBERCOUNT,eax,FALSE
			pop	eax
	@@:
		mov	dwMemberCount,eax
		invoke GetDlgItemInt,hDlgMain,IDE_SUBARRAYLEN,NULL,FALSE
		cmp	eax,DEF_ARRAY_LENGTH
		jnc @F
			mov	eax,DEF_ARRAY_LENGTH
			push	eax
			invoke SetDlgItemInt,hDlgMain,IDE_SUBARRAYLEN,eax,FALSE
			pop	eax
	@@:
		mov	dwSubArrayLen,eax
		invoke GetDlgItemInt,hDlgMain,IDE_ELEMENTSIZE,NULL,FALSE
		cmp	eax,DEF_ELEMENT_SIZE
		jnc @F
			mov	eax,DEF_ELEMENT_SIZE
			push	eax
			invoke SetDlgItemInt,hDlgMain,IDE_ELEMENTSIZE,eax,FALSE
			pop	eax
	@@:
		mov	dwElementSize,eax
		invoke GetDlgItemInt,hDlgMain,IDE_MINSIZE,NULL,FALSE
		cmp	eax,DEF_MIN_SIZE
		jnc @F
			mov	eax,DEF_MIN_SIZE
			push	eax
			invoke SetDlgItemInt,hDlgMain,IDE_MINSIZE,eax,FALSE
			pop	eax
	@@:
		mov	dwMinSize,eax
		invoke GetDlgItemInt,hDlgMain,IDE_MAXSIZE,NULL,FALSE
		cmp	eax,dwMinSize
		jnc @F
			mov	eax,dwMinSize
			push	eax
			invoke SetDlgItemInt,hDlgMain,IDE_MAXSIZE,eax,FALSE
			pop	eax
	@@:
		mov	dwMaxSize,eax

		invoke IsDlgButtonChecked,hDlgMain,IDC_DETAILS
		mov	bDetails,eax

		ret
CheckAll	ENDP

TestListInsert	PROC
		mov	esi,lpMyList
		ASSUME esi:PTR LINKED_LIST

		mov	ebx,dwMemberCount
		mov	edi,dwMode

	@1: ; check index
		push	edi
		or	edi,edi				; insert at the head
		jz @2
		cmp	edi,-1				; insert at the tail
		jz @2
			mov	eax,[esi].dwLength	; else insert randomly
			add	eax,1
			invoke nrandom,eax
			mov	edi,eax

	@2: ; generate random size
		mov	eax,dwMaxSize
		sub	eax,dwMinSize
		jz @F
			invoke nrandom,eax
	@@:
		add	eax,dwMinSize
		; dword alignment
			add	eax,3
			and	eax,-4

		push	eax
		invoke LLIST_insert,esi,edi,eax
		pop	ecx
		or	eax,eax
		jz @3
			cmp	ebx,SHOWN_ENTRIES
			jna @F
		@21:
			pop	edi
			sub	ebx,1
			jnz @1
			mov	eax,TRUE
			jmp @3			
		@@:
			cmp	bDetails,FALSE
			jz @21
				invoke wsprintf,lpTextBuffer,offset sInsertText2,edi,eax,ecx
				invoke SendMessage,hEditLog,EM_SETSEL,-1,0
				invoke SendMessage,hEditLog,EM_REPLACESEL,FALSE,lpTextBuffer
				jmp @21
	@3:
		ret
		ASSUME esi:NOTHING
TestListInsert	ENDP

TestList	PROC
		invoke LLIST_create,100*sizeof MEMBER
		or	eax,eax
		jz @End
		mov	lpMyList,eax

		invoke wsprintf,lpTextBuffer,offset sStartText,offset sTextList
		invoke SendMessage,hEditLog,EM_SETSEL,-1,0
		invoke SendMessage,hEditLog,EM_REPLACESEL,FALSE,lpTextBuffer

	; #1. Insert members
		invoke SendMessage,hEditLog,EM_SETSEL,-1,0
		invoke SendMessage,hEditLog,EM_REPLACESEL,FALSE,offset sInsertText
	timer_begin 1,NORMAL_PRIORITY_CLASS
	invoke TestListInsert
	timer_end
		invoke wsprintf,lpTextBuffer,offset sTimeText,eax
		invoke SendMessage,hEditLog,EM_SETSEL,-1,0
		invoke SendMessage,hEditLog,EM_REPLACESEL,FALSE,lpTextBuffer

	; #2. Read members
		mov	esi,lpMyList
		xor	ebx,ebx
		mov	eax,(LINKED_LIST PTR [esi]).lpHead
	@@:
		add	ebx,1
		mov	eax,(LINKED_MEMBER PTR [eax]).lpNextLink
		cmp	eax,(LINKED_LIST PTR [esi]).lpTail
		jz @F
			mov	[eax+LINKED_userData],ebx		; store dumy data
			jmp @B
	@@:
		add	ebx,1
		invoke wsprintf,lpTextBuffer,offset sCountText,ebx
		invoke SendMessage,hEditLog,EM_SETSEL,-1,0
		invoke SendMessage,hEditLog,EM_REPLACESEL,FALSE,lpTextBuffer

	; #21. Random select members
		invoke SendMessage,hEditLog,EM_SETSEL,-1,0
		invoke SendMessage,hEditLog,EM_REPLACESEL,FALSE,offset sRandText
		mov	ebx,1
	@21:
		invoke nrandom,(LINKED_LIST PTR [esi]).dwLength
		invoke LLIST_retrieve,esi,eax,NULL
		or	eax,eax
		jz @F
		push	eax
		invoke LLIST_retrieve,esi,NULL,eax
		pop	ecx
		or	eax,eax
		jz @F
		cmp	[ecx+LINKED_userData],ebx
		jz @F
			cmp	bDetails,1
			jnz @F
			invoke wsprintf,lpTextBuffer,offset sRetrieveText,ebx,eax,ecx
			invoke SendMessage,hEditLog,EM_SETSEL,-1,0
			invoke SendMessage,hEditLog,EM_REPLACESEL,FALSE,lpTextBuffer
	@@:
		add	ebx,1
		cmp	ebx,SHOWN_ENTRIES
		jna @21

	; #3. Remove members
		invoke SendMessage,hEditLog,EM_SETSEL,-1,0
		invoke SendMessage,hEditLog,EM_REPLACESEL,FALSE,offset sRemoveText

		mov	edx,lpMyList
		mov	ebx,dwMemberCount
		mov	eax,(LINKED_LIST PTR [edx]).lpHead
	timer_begin 1,NORMAL_PRIORITY_CLASS
	@@:
		invoke LLIST_remove,lpMyList,1,NULL
		sub	ebx,1
		jnz @B
	timer_end
		invoke wsprintf,lpTextBuffer,offset sTimeText,eax
		invoke SendMessage,hEditLog,EM_SETSEL,-1,0
		invoke SendMessage,hEditLog,EM_REPLACESEL,FALSE,lpTextBuffer

	; End
		invoke LLIST_destroy,lpMyList

		invoke SendMessage,hEditLog,EM_SETSEL,-1,0
		invoke SendMessage,hEditLog,EM_REPLACESEL,FALSE,offset sEndText
	@End:
		ret
TestList	ENDP


TestArray	PROC
		invoke LARRAY_create,dwElementSize,dwSubArrayLen
		or	eax,eax
		jz @End
		mov	lpMyList,eax

		invoke wsprintf,lpTextBuffer,offset sStartText,offset sTextArray
		invoke SendMessage,hEditLog,EM_SETSEL,-1,0
		invoke SendMessage,hEditLog,EM_REPLACESEL,FALSE,lpTextBuffer

	; #1. Insert members
		invoke SendMessage,hEditLog,EM_SETSEL,-1,0
		invoke SendMessage,hEditLog,EM_REPLACESEL,FALSE,offset sInsertText
	timer_begin 1,NORMAL_PRIORITY_CLASS
		mov	ebx,dwMemberCount
	@@:
		invoke LARRAY_insert,lpMyList
		sub	ebx,1
		jnz @B
	timer_end
		invoke wsprintf,lpTextBuffer,offset sTimeText,eax
		invoke SendMessage,hEditLog,EM_SETSEL,-1,0
		invoke SendMessage,hEditLog,EM_REPLACESEL,FALSE,lpTextBuffer

	; #2. Read members
		mov	esi,lpMyList
		xor	ebx,ebx
		mov	eax,(LINKED_LIST PTR [esi]).lpHead
	@2:
		mov	eax,(LINKED_MEMBER PTR [eax]).lpNextLink
		push	eax
		cmp	eax,(LINKED_LIST PTR [esi]).lpTail
		jz @21
		add	eax,sizeof LINKED_SUBARRAY
		mov	ecx,(LINKED_ARRAY PTR [esi]).dwSubArrayLen
	@@:
		mov	[eax],ebx
		add	eax,(LINKED_ARRAY PTR [esi]).dwElementSize
		add	ebx,1
		cmp	ebx,(LINKED_ARRAY PTR [esi]).dwElementCount
		jz @21
		sub	ecx,1
		jnz @B

		pop	eax
		jmp @2
	@21:
		pop	eax

		invoke wsprintf,lpTextBuffer,offset sCountText,(LINKED_LIST PTR [esi]).dwLength
		invoke SendMessage,hEditLog,EM_SETSEL,-1,0
		invoke SendMessage,hEditLog,EM_REPLACESEL,FALSE,lpTextBuffer

	; #21. Random select members
		invoke SendMessage,hEditLog,EM_SETSEL,-1,0
		invoke SendMessage,hEditLog,EM_REPLACESEL,FALSE,offset sRandText

		mov	edi,(LINKED_ARRAY PTR [esi]).dwElementCount
		mov	ebx,1
		sub	edi,1
	@210:
		invoke nrandom,edi
		add	eax,1
		invoke LARRAY_retrieve,esi,eax,NULL
		or	eax,eax
		jz @F
		push	eax
		invoke LARRAY_retrieve,esi,NULL,eax
		pop	ecx
		or	eax,eax
		jz @F
		cmp	[ecx],ebx
		jz @F
			cmp	bDetails,1
			jnz @F
			invoke wsprintf,lpTextBuffer,offset sRetrieveText,ebx,eax,ecx
			invoke SendMessage,hEditLog,EM_SETSEL,-1,0
			invoke SendMessage,hEditLog,EM_REPLACESEL,FALSE,lpTextBuffer
	@@:
		add	ebx,1
		cmp	ebx,SHOWN_ENTRIES
		jna @210

	; #3. Remove members
		invoke SendMessage,hEditLog,EM_SETSEL,-1,0
		invoke SendMessage,hEditLog,EM_REPLACESEL,FALSE,offset sRemoveText

		mov	esi,lpMyList
		mov	ebx,dwMemberCount
		mov	eax,(LINKED_LIST PTR [esi]).lpHead
	timer_begin 1,NORMAL_PRIORITY_CLASS
	@@:
		invoke LARRAY_remove,lpMyList,1,NULL
		sub	ebx,1
		jnz @B
	timer_end
		invoke wsprintf,lpTextBuffer,offset sTimeText,eax
		invoke SendMessage,hEditLog,EM_SETSEL,-1,0
		invoke SendMessage,hEditLog,EM_REPLACESEL,FALSE,lpTextBuffer

	; End
		invoke LARRAY_destroy,lpMyList

		invoke SendMessage,hEditLog,EM_SETSEL,-1,0
		invoke SendMessage,hEditLog,EM_REPLACESEL,FALSE,offset sEndText

	@End:
		ret
TestArray	ENDP


RunTests	PROC USES ebx edi esi
LOCAL lpStr:DWORD

		invoke CheckAll

		invoke IsDlgButtonChecked,hDlgMain,IDC_LIST
		cmp	eax,BST_CHECKED
		jnz @TestArray

			invoke TestList

@TestArray:
		invoke IsDlgButtonChecked,hDlgMain,IDC_ARRAY
		cmp	eax,BST_CHECKED
		jnz @End

			invoke TestArray
@End:
		ret
RunTests	ENDP
